// rmbkold.h - main
//
// Old Mail Arrangement Plug-in for Becky! 2
// Copyright (C) 2000 by Tietew
//
#pragma once

#include "BeckyAPI.h"
#include "resource.h"
#include "strhelp.h"

// get count of array
#define countof(s) (sizeof(s)/sizeof((s)[0]))

// global variables
extern HINSTANCE g_hInstance;
extern char g_szIni[];
extern CBeckyAPI bka;
extern HIMAGELIST g_hilFolders;
extern COLORREF g_crUser[16];

// Section and key string of ini
#define INI_SECTION				"bkrmold"
#define INI_KEY_DAYS			"Days"
#define INI_KEY_MAILS			"Mails"
#define INI_KEY_THREADS			"Threads"
#define INI_KEY_FILTER			"Filter"
#define INI_KEY_RECURSIVE		"Recursive"
#define INI_KEY_BEHAVIOR		"Behavior"
#define INI_KEY_HOT_ARRANGE		"ArrangeHotKey"
#define INI_KEY_HOT_SCHEDULE	"ScheduleHotKey"
#define INI_KEY_EXITSCHEDULE	"ExitSchedule"
#define INI_KEY_LOCKOUT			"Lockout"
#define INI_KEY_LOCKOUTNUM		"LockoutNum"
#define INI_KEY_LOCKOUTUNIT		"LockoutUnit"
#define INI_SEC_SCHEDULE		"Schedule"
#define INI_SEC_BKUPDATE		"BkUpdate"
#define INI_KEY_URL				"URL"

// Command IDs
#define BKID_VIEW_CLOSEALLTHREADS	32958
#define BKID_VIEW_OPENALLTHREADS	32959
#define BKID_MAIL_DELETE			32836

// Magic Numbers of FILETIME
#define FT_SECOND	(10000000i64)
#define FT_MINUTE	(FT_SECOND * 60)
#define FT_HOUR		(FT_MINUTE * 60)
#define FT_DAY		(FT_HOUR * 24)

// Easy way to write integer value to ini
inline BOOL WriteIniInt(LPCTSTR lpAppName, LPCTSTR lpKeyName, int n, LPCTSTR lpFileName)
{
	char str[32];
	wsprintf(str, "%d", n);
	return WritePrivateProfileString(lpAppName, lpKeyName, str, lpFileName);
}

// Easy way to get settings
inline int GetIniDays()
	{ return GetPrivateProfileInt(INI_SECTION, INI_KEY_DAYS, 30, g_szIni); }
inline int GetIniMails()
	{ return GetPrivateProfileInt(INI_SECTION, INI_KEY_MAILS, 1000, g_szIni); }
inline BOOL GetIniThreads()
	{ return GetPrivateProfileInt(INI_SECTION, INI_KEY_THREADS, 0, g_szIni); }
inline int GetIniFilter()
	{ return GetPrivateProfileInt(INI_SECTION, INI_KEY_FILTER, 0, g_szIni); }
inline BOOL GetIniRecursive()
	{ return GetPrivateProfileInt(INI_SECTION, INI_KEY_RECURSIVE, 0, g_szIni); }
inline int GetIniBehavior()
	{ return GetPrivateProfileInt(INI_SECTION, INI_KEY_BEHAVIOR, 0, g_szIni); }
inline WORD GetIniHotArrange()
	{ return (WORD)GetPrivateProfileInt(INI_SECTION, INI_KEY_HOT_ARRANGE, 0, g_szIni); }
inline WORD GetIniHotSchedule()
	{ return (WORD)GetPrivateProfileInt(INI_SECTION, INI_KEY_HOT_SCHEDULE, 0, g_szIni); }
inline BOOL GetIniExitSchedule()
	{ return GetPrivateProfileInt(INI_SECTION, INI_KEY_EXITSCHEDULE, 0, g_szIni); }
inline BOOL GetIniLockout()
	{ return GetPrivateProfileInt(INI_SECTION, INI_KEY_LOCKOUT, 0, g_szIni); }
inline BOOL GetIniLockoutNum()
	{ return GetPrivateProfileInt(INI_SECTION, INI_KEY_LOCKOUTNUM, 0, g_szIni); }
inline BOOL GetIniLockoutUnit()
	{ return GetPrivateProfileInt(INI_SECTION, INI_KEY_LOCKOUTUNIT, 0, g_szIni); }

// ID-Behavior mapping
inline UINT IDFromBehavior(int nBehavior)
	{ return nBehavior == 2 ? IDC_REMOVE : (nBehavior == 1 ? IDC_MOVE : IDC_SELECT); }
inline int BehaviorFromID(UINT id)
	{ return id == IDC_REMOVE ? 2 : (id == IDC_MOVE ? 1 : 0); }

// CheckBox
inline bool IsDlgButtonChecked2(HWND hDlg, int nIDButton)
	{ return IsDlgButtonChecked(hDlg, nIDButton) == BST_CHECKED; }
inline BOOL CheckDlgButton2(HWND hDlg, int nIDButton, BOOL bCheck)
	{ return CheckDlgButton(hDlg, nIDButton, bCheck ? BST_CHECKED : BST_UNCHECKED); }

// Functions
void SettingDlg(HWND hWnd);

